<template>
  <gl-form-group label="Group by" label-for="group-by-listbox">
    <!--
      GlCollapsibleListbox requires client-only.
      See https://gitlab.com/gitlab-org/gitlab-ui/-/issues/1933.
    -->
    <client-only>
      <gl-collapsible-listbox
        id="group-by-listbox"
        :selected="value"
        :items="$options.groupByOptions"
        @select="$emit('input', $event)"
      />
    </client-only>
  </gl-form-group>
</template>

<script>
import GlFormGroup from '@gitlab/ui/src/components/base/form/form_group/form_group.vue';

export const GROUP_BY_DIRECTORY = 'directory';
export const GROUP_BY_GROUP = 'group';
export const GROUP_BY_SEVERITY = 'severity';
export const GROUP_BY_FILE_TYPE = 'file-type';
export const GROUP_BY_NOTHING = 'nothing';

export const groupByOptions = [
  {
    value: GROUP_BY_DIRECTORY,
    text: 'Directory',
  },
  {
    value: GROUP_BY_GROUP,
    text: 'Group (Team)',
  },
  {
    value: GROUP_BY_SEVERITY,
    text: 'Severity',
  },
  {
    value: GROUP_BY_FILE_TYPE,
    text: 'File Type',
  },
  {
    value: GROUP_BY_NOTHING,
    text: 'Nothing',
  },
];

export default {
  name: 'GroupBy',
  components: {
    GlFormGroup,

    // The GlOutsideDirective used by GlCollapsibleListbox has an import-time dependency
    // on `window`, so work around that with a dynamic import.
    // See https://gitlab.com/gitlab-org/gitlab-ui/-/issues/1900.
    GlCollapsibleListbox: () =>
      import('@gitlab/ui/src/components/base/new_dropdowns/listbox/listbox.vue'),
  },
  props: {
    value: {
      type: String,
      required: true,
    },
  },
  groupByOptions,
};
</script>
